# Copyright 2014-2023 the openage authors. See copying.md for legal info.

# warning: auto-generated file by cmake. look at the template file instead.

# autogen produces lines of config-dependent length (e.g. COMPILERFLAGS).
# pylint: disable=line-too-long

"""
Project configuration, written by the build system.
"""

import sys
import importlib
import cython
import mako
import numpy
import PIL
import pygments

GLOBAL_CONFIG_DIR = "/usr/local/etc/openage"
GLOBAL_ASSET_DIR = "/usr/local/share/openage"
BUILD_SRC_DIR = "/wrkdirs/usr/ports/games/openage/work/openage-0.6.0"
BUILD_BIN_DIR = "/wrkdirs/usr/ports/games/openage/work/.build"

# version information
VERSION = ""
CONFIG_OPTIONS = "opengl"

# toolchain
COMPILER = "Clang 18.1.6"
COMPILERFLAGS = "-O2 -pipe -fstack-protector-strong -fno-strict-aliasing"
CICFGVERSION = "NOT SET"
PYTHONINTERPRETER = sys.version
PYTHONCAPI = sys.api_version
CYTHONVERSION = cython.__version__
MAKOVERSION = mako.__version__
NUMPYVERSION = numpy.__version__
PILVERSION = PIL.__version__
PYGMENTSVERSION = pygments.__version__

# features
WITH_NCURSES = ("false" == "true")


try:
    importlib.import_module("openage.devmode")
    DEVMODE = True
except ImportError:
    DEVMODE = False
